buildGOgraph <- function(useenv=GOMFPARENTS) {
 library(GO)
 library(Biobase)
 library(graph)
 nds <- unique(ls(env=useenv))
 eds <- mget( nds, env=useenv, ifnotfound=NA )
 eds <- lapply( eds, function(x) {
     lk <- match(x,nds)
     if (length(lk)==0) return(list(edges=character(0)))
     else if (length(lk)==1 && is.na(lk)) return(list(edges=character(0)))
     else if (any(is.na(lk))) return(list(edges=lk[!is.na(lk)]))
     return(list(edges=lk))
     })
 tmp <- new("graphNEL", nodes=nds, edgeL=eds, edgemode="directed")
 attr(tmp,"toolInfo") <- library(help=GO)$info[[2]][[2]]
 tmp
}

