\name{depthStruct}
\alias{depthStruct}
\alias{DMdepth}
\alias{ontoDepth}
\description{return a list of environments giving mapping from
node name to rooted DAG depth and from depth to vector of names of nodes
at that depth  }
\title{tools for manipulating depth concepts for rooted DAGs
}
\usage{
depthStruct(rg)
ontoDepth(rg)
DMdepth(g, maxd)
}
\arguments{
  \item{rg}{ rg: instance of class rootedDAG}
  \item{g}{ rg: instance of class depth}
  \item{maxd}{ maxd: bound on depth to be measured}
}
%\details{
%}
\value{depthStruct: a list of two environments (see examples).
}
%\references{  }
\author{Vince Carey <stvjc@channing.harvard.edu>}
\note{ontoDepth is the workhorse for depthStruct.
DMdepth is a function that works on a plain graph, creating
the 'daughter matrix' and computing depths.  }


%\seealso{  }

\examples{
data(litOnto)
print(litOnto)
g1 <- new("rootedDAG", DAG=litOnto, root="A")
o1 <- new("ontology", name="demo", version="0.1",
        rDAG=g1)
print(ds <- depthStruct(g1))
ds$tag2depth("A")
ds$tag2depth("H")
ds$depth2tag(2)
}
\keyword{ models }
