\name{taggedHierNomenclature-class}
\docType{class}
\alias{taggedHierNomenclature-class}
\alias{taggedHierNomenclature}
\alias{children,character,taggedHierNomenclature-method}
\alias{parents,character,taggedHierNomenclature-method}
\alias{show,taggedHierNomenclature-method}

\title{Class "taggedHierNomenclature" ~~~ }
\description{  representation of a DAG-structured nomenclature }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("taggedHierNomenclature", ...)}.
See example
}
\section{Slots}{
  \describe{
    \item{\code{tags}:}{Object of class \code{"character"}  ;
formal tags, often semantically opaque }
    \item{\code{parents}:}{Object of class \code{"character"}; terms
regarded as generalizations of the given term }
    \item{\code{delim}:}{Object of class \code{"character"};
the parent strings are decomposed using this delimiter }
    \item{\code{rootToken}:}{Object of class \code{"character"};
token used to indicate root of DAG }
    \item{\code{name}:}{Object of class \code{"character"} 
name of nomenclature }
    \item{\code{provenance}:}{Object of class \code{"provStruct"} information
on origins of vocabulary }
    \item{\code{inMappings}:}{Object of class \code{"character"} list
of mappings in which the term is employed }
    \item{\code{terms}:}{Object of class \code{"character"} actual
subject matter terms being organized }
    \item{\code{definitions}:}{Object of class \code{"character"} verbal
definitions of terms }
  }
}
\section{Extends}{
Class \code{"nomenclature"}, directly.
}
\section{Methods}{
  \describe{
    \item{children}{\code{signature(term = "character", nom = "taggedHierNomenclature")}: ... }
    \item{parents}{\code{signature(term = "character", nom = "taggedHierNomenclature")}: ... }
    \item{show}{\code{signature(object = "taggedHierNomenclature")}: ... }
  }
}
\references{ }
\author{ VJ Carey <stvjc@channing.harvard.edu> }

\seealso{
\code{\link{GDI_NCIThesaurus}}
}
\examples{
data(GDI_NCIThesaurus)
GDI_NCIThesaurus
}
\keyword{classes}
